_G.TurretFeedBackHack = {
  active_feedback_jammers = 0
}

if RequiredScript == "lib/units/equipment/ecm_jammer/ecmjammerbase" then

  local _set_feedback_active_original = ECMJammerBase._set_feedback_active
  function ECMJammerBase:_set_feedback_active(...)
    local active_state = self:feedback_active()
    
    _set_feedback_active_original(self, ...)
    
    if active_state ~= self:feedback_active() then
      TurretFeedBackHack.active_feedback_jammers = math.max(0, TurretFeedBackHack.active_feedback_jammers + (active_state and -1 or 1))
    end
  end

end

if RequiredScript == "lib/units/equipment/sentry_gun/sentrygunmovement" then

  function SentryGunMovement:_upd_hacking(t, dt)
    if not self._tweak.ECM_HACKABLE then
      return
    end

    local is_hacking_active
    if Network:is_server() then
      is_hacking_active = TurretFeedBackHack.active_feedback_jammers > 0
    elseif self._team.id == "hacked_turret" then
      is_hacking_active = true
    end

    if self._is_hacked then
      if not is_hacking_active then
        self._is_hacked = nil

        if Network:is_server() then
          local original_team = self._original_team
          self._original_team = nil
          self:set_team(original_team)
        end

        if self._hacked_stop_snd_event then
          self._sound_source:post_event(self._hacked_stop_snd_event)
        end

        if Network:is_server() then
          self._unit:brain():on_hacked_end()
        end
      end
    elseif is_hacking_active then
      self._is_hacked = true

      if Network:is_server() then
        local original_team = self._team
        self:set_team(managers.groupai:state():team_data("hacked_turret"))
        self._original_team = original_team
      end

      if self._hacked_start_snd_event then
        self._sound_source:post_event(self._hacked_start_snd_event)
      end

      if Network:is_server() then
        self._unit:brain():on_hacked_start()
      end
    end
  end

end